<template>
  <b-container fluid>
    <b-alert show :variant="alert" v-model="showAlert" dismissible>
        <strong>{{alertMessage}}</strong>
    </b-alert>
    <b-table
      responsive
      striped
      hover
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      :items="results"
      :fields="fields"
      :current-page="currentPage"
      :per-page="perPage"
      class="table-platone"
    >
    <template #cell(id_consumer)="data">
        {{ data.item.id_consumer }}
      </template>
      <template #cell(topic)="data">
        {{ data.item.topic }}
      </template>
     <template #cell(status)="data">
        <h5><b-badge v-if="data.item.status==='REQUESTED'" variant="info">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status==='ACCEPTED'" variant="success">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status==='REFUSED'" variant="danger ">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status===''" variant="">{{data.item.status}}</b-badge></h5>
      </template>
      <template #cell(creation_date)="data">
        {{ data.item.creation_date | formatDate }}
      </template>
      <template #cell(modification_date)="data">
        {{ data.item.modification_date | formatDate }}
      </template>
      <template #cell()="data">
        <b-button v-b-tooltip.hover title="Accept" size="sm" class="mf-1" variant="success" v-on:click="setStatus(data.item.id_consumer, data.item.topic, 'ACCEPTED')">A</b-button>
        <b-button v-b-tooltip.hover title="Refuse" size="sm" class="mf-1" variant="danger" v-on:click="setStatus(data.item.id_consumer, data.item.topic,'REFUSED')">R</b-button>
      </template>
    </b-table>
    <b-pagination
      v-model="currentPage"
      :total-rows="results.length"
      :per-page="perPage"
      aria-controls="my-table"
    ></b-pagination>
  </b-container>
</template>

<style>
  input {
    text-align: center;
  }
  .home {
    text-align: center;
  }
  .home .lead {
    font-weight: 200;
    font-size: 1.5rem;
  }
  .b-search {
    margin-top: 10px;
    background-color: #497774;
  }
  .card {
    margin-top: 20px;
  }
  .json {
    text-align: left;
    width: 50%;
  }
  .hash {
    width: 50%;
  }
  .verifiedHash {
    margin-top: 40px;
  }
  .center {
    text-align: center;
  }
</style>

<script>
import SubscriptionService from '@/services/SubscriptionService'
import ConsumerService from '@/services/ConsumerService'

export default {
  name: 'home',
  mounted () {
    this.getSubscriptions()
  },
  data () {
    return {
      user: this.$session.get('user'),
      result: null,
      hash: null,
      text: '',
      vHash: null,
      alert: 'light',
      loading: false,
      sortBy: 'start',
      sortDesc: true,
      results: [],
      fields: [
        { key: 'id_consumer', label: 'Consumer', sortable: true },
        { key: 'topic', label: 'Topic', sortable: true },
        { key: 'status', label: 'Status', sortable: true },
        { key: 'creation_date', label: 'Creation Date', sortable: true },
        { key: 'modification_date', label: 'Modification Date', sortable: true },
        { key: 'action', label: 'Actions' }
      ],
      form: {},
      currentPage: 1,
      perPage: 10,
      showAlert: false,
      alertMessage: ''
    }
  },
  methods: {
    async getSubscriptions () {
      const response = await SubscriptionService.getSubscriptions(this.user.topic)
      console.log('Response ' + JSON.stringify(response.data))
      this.results = response.data
    },
    async setStatus (idConsumer, topic, status) {
      this.showAlert = true
      setTimeout(() => {
        this.showAlert = false
      }, 4000)
      const params = {}
      params.id_producer = this.user.username
      params.id_consumer = idConsumer
      params.topic = topic
      params.status = status
      params.modification_date = Date.now()
      console.log('STATUS ' + JSON.stringify(params.status))
      if (params.status === 'ACCEPTED') {
        this.alert = 'success'
        this.alertMessage = 'Subscription Accepted'
      } else {
        this.alert = 'danger'
        this.alertMessage = 'Subscription Refused'
      }
      await ConsumerService.subscribe(params)
      await this.getSubscriptions()
    }
  }
}
</script>
